$border-radius: 0.3em;

$vertical-padding-pill: 0.6em;
$side-padding-pill: 1.2em;

%buttonReset {
  font-family: var(--font-font-family-base);
  border: none;
  background: none;
  max-width: 100%;
  display: inline-flex;
  align-items: center;
  line-height: 1.1em;
  cursor: pointer;
  font-size: var(--font-size-m);
  border-radius: $border-radius;
  padding: 0.6em 1.1em;
  font-weight: 500;
  transition: 0.05s background-color;
  overflow: hidden;
  justify-content: center;

  &.l {
    font-size: var(--font-size-l);
    padding: 0.8em 1.55em;
  }

  &.s {
    font-size: var(--font-size-s);
    padding: 0.55em 1.1em;

    &.bare {
      padding: 0.3em 0;
    }
    
    [class*='icon-'] {
      font-size: 1.3em;
    }
  }

  &.slim {
    padding-top: 0;
    padding-bottom: 0;
  }

  [class^='icon-'] {
    display: inline-block;
    line-height: 1.1em;
  }

  &[disabled],
  &.disabled {
    opacity: 0.45;
    cursor: not-allowed;
    pointer-events: none;
  }
}

%base {
  background: var(--background, var(--color-brand-weaker));
  color: var(--color, var(--color-brand-base));

  &.inverted {
    background: rgba(white, 0.12);
    color: white;
  }
}

%cta {
  background: var(--color-brand-base);
  color: var(--color, white);

  &.inverted {
    background: white;
    color: var(--color-brand-base);

    &:hover {
      background: rgba(white, 0.95);
    }
  }
}

%bare {
  color: var(--color, var(--color-brand-base));
  padding-left: 2px;
  padding-right: 2px;
  border-radius: 0;

  &.inverted {
    color: white;
  }

  &[disabled] {
    color: var(--color-text-weaker);
  }
}

%outline {
  color: var(--color, var(--color-brand-base));
  box-shadow: inset 0 0 0 1px var(--color, var(--color-brand-base));

  &.filled {
    background: white;
  }

  &.l {
    box-shadow: inset 0 0 0 1px var(--color, var(--color-brand-base));
  }

  &.inverted {
    color: var(--color, white);
    box-shadow: inset 0 0 0 1px var(--color, white);

    &.l {
      box-shadow: inset 0 0 0 1px var(--color, white);
    }
  }
}

%ghost {
  box-shadow: inset 0 0 0 1px var(--color-foreground-weaker);
  color: var(--color, var(--color-text-base));
}

.group {
  display: flex;
  align-items: center;
  max-width: 100%;
  padding-left: 0;
  margin: 0;

  &.equal {
    & > * {
      flex-grow: 1;
    }
  }

  & > * {
    border-radius: 0;
    list-style: none;

    &:focus,
    .selected,
    &[aria-selected='true'],
    &[aria-current='page'],
    &[aria-current='location'] {
      z-index: 1; // make sure selected element is above the border or others
    }
  }

  .outline {
    margin-right: -1px;
  }

  .ghost {
    margin-right: -1px;
  }

  .bare {
    margin-right: .7em;

    &:last-child {
      margin-right: 0;
    }
  }

  & > *:first-child:not(.bare) {
    border-top-left-radius: $border-radius;
    border-bottom-left-radius: $border-radius;
  }

  & > *:last-child:not(.bare) {
    border-top-right-radius: $border-radius;
    border-bottom-right-radius: $border-radius;
  }
}

.base {
  @extend %buttonReset;
  @extend %base;

  &:hover:not(:disabled),
  &:focus {
    background-color: var(--color-brand-weaker);

    &.inverted {
      background-color: rgba(white, 0.2);
    }
  }

  &:active,
  &.selected,
  &[aria-selected='true'],
  &[aria-current='page'],
  &[aria-current='location'] {
    background-color: var(--color-brand-weaker);

    &.inverted {
      background-color: rgba(white, 0.25);
    }
  }
}

.cta {
  @extend %buttonReset;
  @extend %cta;

  &:hover {
    background: var(--color-brand-stronger);
  }

  &:active,
  &:focus,
  &.selected,
  &[aria-selected='true'],
  &[aria-current='page'],
  &[aria-current='location'] {
    background: var(--color-brand-stronger);
  }
}

.bare {
  @extend %buttonReset;
  @extend %bare;

  padding-left: 0;
  padding-right: 0;

  &.selected,
  &[aria-selected='true'],
  &[aria-current='page'],
  &[aria-current='location'] {
    // background: linear-gradient(
    //   transparent,
    //   transparent 90%,
    //   var(--color, var(--color-brand-base)) 90%,
    //   var(--color, var(--color-brand-base)) 100%,
    //   transparent 100%
    // );
    background: linear-gradient(
      to top,
      var(--color, var(--color-brand-base)) 2px,
      transparent 2px,
      transparent
    );
  }
}

.outline {
  @extend %buttonReset;
  @extend %outline;

  &:hover:enabled,
  &:focus {
    background: var(--color-brand-weakest);

    &:active,
    &.selected {
      background: var(--color-brand-stronger);
      color: white;
    }
  }

  &:active,
  &.selected {
    background: var(--color-brand-base);
    color: white;
  }
}

.ghost {
  @extend %buttonReset;
  @extend %ghost;

  &:hover:enabled,
  &:focus {
    background: var(--color-text-weakest);
    color: var(--color-brand-base);
  }

  &:active,
  &.selected {
    background: var(--color-text-weakest);
    color: var(--color-brand-base);
  }
}

.icon {
  padding: 0 !important;
  border-radius: 100%;
  justify-content: center;
  align-self: center;
  display: inline-flex;
  align-items: center;
  width: 2.2em;
  height: 2.2em;
}

.pill {
  border-radius: 2em;
  padding: $vertical-padding-pill $side-padding-pill;
}

.secondary {
  font-weight: 400;
}

.raised {
  box-shadow: 0 0 0.6em rgba(black, 0.2);
}

.buttonText {
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  // To prevent vertical overflow from being hidden
  padding: 0.6em 0;
  margin: -0.6em 0;
}

.spaced {
  margin-right: 1.5em;
}

// visual padding adjustments if there are icons present
.iconBefore {
  justify-content: space-between;

  &.bare {
    padding-left: 0.3em;
  }

  &.pill [class*='icon-'] {
    transform: translateX(-0.3em);
  }

  [class*='icon-'] {
    transform: translateX(-0.3em);
  }
}

.iconAfter {
  justify-content: space-between;

  &.bare {
    padding-right: 0.6em;
  }

  &.pill [class*='icon-'] {
    transform: translateX(0.6em);
  }

  [class*='icon-'] {
    transform: translateX(0.6em);
  }
}

.iconBeforeAndAfter {
  &.bare {
    padding-right: 0.6em;
    padding-left: 0.6em;
  }

  [class*='icon-'] {
    &:first-child {
      transform: translateX(-0.6em);
    }

    &:last-child {
      transform: translateX(0.6em);
    }
  }
}
